#include <list>
#include <cmath>
#include "Function.h"
#include "Spreadsheet.h"

using namespace std;

IFunction::~IFunction() 
{}


BinOp::BinOp(FuncPtr fp,Cell *arg1, Cell *arg2) 
: func(fp), lhs(arg1), rhs(arg2)
{}

BinOp::~BinOp()
{}

Value BinOp::evaluate() const
{
    // This just forwards to the relevant free
    // function:
    return func(lhs->getValue(),rhs->getValue());
}

list<Cell*> BinOp::getSources()
{
    // Report the set of source cells used
    // by this function:
    list<Cell*> tmp;
    tmp.push_back(lhs);
    tmp.push_back(rhs);
    return tmp;
}

Value add(Value a,Value b) {return a+b;} 
Value subtract(Value a,Value b) {return a-b;}
Value multiply(Value a,Value b) {return a*b;}
Value divide(Value a, Value b) {return a/b;}
Value modfunc(Value a,Value b) {return a - floor(a/b)*b;}

