#include "PubSub.h"
#include <algorithm>
using namespace std;

void Publisher::notify() const
{
    // Call update() for each subscriber:
    for(SubColl::const_iterator i = subColl.begin();
        i != subColl.end();
        ++i)
    {
        ISubscriber * s = *i;
        s->update(this);
    }   
}

void Publisher::subscribe(ISubscriber *sub)
{
    // Add the subscriber if they aren't already subscribed:
    if (subColl.end() == find(subColl.begin(),subColl.end(),sub))
        subColl.push_back(sub);
}

void Publisher::unsubscribe(ISubscriber *sub)
{
    // Remove the subscriber (no-op if not subscribed):
    subColl.remove(sub);
}

ISubscriber::~ISubscriber()
{}